<?php
/*
	Oracle implementation of DB Access function for IWWB REST Service.
	
	Author: Andreas Jerke
	(c) 2003/07/02 Engine GmbH & CO KG
	contact: aj@engine.de	
*/

// global variable for statement, needed for error tracking
$stmt = -1;

// Create database connection.
//
// return: DB Connection Link or false on error
function db_open() 
{
	return @OCILogOn(DB_USER, DB_PASS, DB_NAME);
}

// Close database connection.
//
// $dblink: DB Connection Link
// return: false on error
function db_close($dblink)
{
	return @OCILogOff($dblink);
}

// Query database.
//
// $sql: SQL Statement
// $dblink: DB Connection Link
// return: Result identifier or false on error
function db_query($sql,$dblink)
{
	global $stmt;
	$stmt = @OCIParse($dblink,$sql);
	if (!$stmt) return false;
	if (!@OCIExecute($stmt)) return false;
	return $stmt;
}

// fetch associative array
//
// $dbresult: Result identifier
// return: associative array containing row data or false if no data available
function db_fetch_assoc($dbresult)
{
	if (@OCIFetchInto ( $dbresult, $resultrow , OCI_ASSOC)) {
		return $resultrow;
	}
	return false;
}

// returns error as string
function db_error()
{
	global $stmt;
	$error = OCIError();
	if (empty($error)) {
		$errorArr = OCIError($stmt);
		$errorStr = "[Oracle]\n";
		while ( $errorRow = each ($errorArr)) {
			$errorStr.=$errorRow[0].":".$errorRow[1]."\n";
		}
		return $errorStr;
	}
	return "[Oracle]".$error;
}

function db_getdate($querydate)
{
	//separate date
	$arr = explode(".",$querydate);
	return $arr[2].$arr[1].$arr[0];
}


?>