<?php
/*******************************************************************************************
IWWB REST Service, Linux/UNIX | Apache | PHP | Mysql/Sybase/...

Requierements : PHP 4.0.3

Author: Andreas Jerke
(c) 2003 Engine GmbH & Co KG
Contact: aj@engine.de

*******************************************************************************************/
//include global configuration
include ("include/connect.php");

//include database access functions
include ("include/".DB_TYPE."_tools.php");

writeHeader();

$debug = false;
// if (isset($HTTP_GET_VARS["debug"])) $debug = true;
if (isset($_GET["debug"])) $debug = true;

/*****************************
dispatcher
*****************************/
// $method = $HTTP_GET_VARS["method"];
$method = isset($_GET["method"]) ? $_GET["method"];



if (!isset($_GET["pid1"])) $_GET["pid1"]='';
if (!isset($_GET["pid2"])) $_GET["pid2"]='';
if (!isset($_GET["lastUpdate"])) $_GET["lastUpdate"]='';

// $_GET["entries"]

if ($method=="getChangedCoursesCount") {
	writeChangedCoursesCount();
} else if ($method=="getChangedCoursesXML") {
	writeChangedCoursesXML();
} else if ($method=="getSchemeXML") {
	//NOT IMPLEMENTED YET
}

writeFooter();
die();

/*****************************
write changed courses count
*****************************/
function writeChangedCoursesCount() {
  


	$dblink = db_open();
	if ($dblink) {
		// global $HTTP_GET_VARS;
		// $sql=getChangedCoursesCountSQL(	$HTTP_GET_VARS["pid1"], $HTTP_GET_VARS["pid2"], db_getdate($HTTP_GET_VARS["lastUpdate"]));
		$sql=getChangedCoursesCountSQL($_GET["pid1"], $_GET["pid2"], db_getdate($_GET["lastUpdate"]));
		writeDebug($sql);
		$result = db_query($sql,$dblink);
		if (!$result) {
			//error !
			writeError("Could not query count courses !");
			return;
		}
		$resultArr = db_fetch_assoc($result);
		if (!$resultArr) {
			//error !
			writeError("Could not query count courses !");
			return;
		}
		if (DB_TYPE=="oracle") {
			writeChangedCourses($resultArr["CNT"]);
		} else {
			writeChangedCourses($resultArr["cnt"]);
		}
		db_close($dblink);
	} else {
		//error !
		writeError("Could not open DB connection !");
	}
}

/*****************************
write changed courses XML
*****************************/
function writeChangedCoursesXML() {
	$dblink = db_open();
	if ($dblink) {
		// global $HTTP_GET_VARS;
		// $sql=getChangedCoursesXMLSQL(	$HTTP_GET_VARS["pid1"], $HTTP_GET_VARS["pid2"], db_getdate($HTTP_GET_VARS["lastUpdate"]), $HTTP_GET_VARS["entries"]);
		$sql=getChangedCoursesXMLSQL(	$_GET["pid1"], $_GET["pid2"], db_getdate($_GET["lastUpdate"]), $_GET["entries"]);
		writeDebug($sql);
		$result = db_query($sql,$dblink);
		if (!$result) {
			//error !
			writeError("Could not query courses XML !");
			return;
		}
		writeCoursesXML($result);
		db_close($dblink);
	} else {
		//error !
		writeError("Could not open DB connection !");
	}
}

/*****************************
Build SQL Statements
*****************************/

function getChangedCoursesCountSQL($lastPID1,$lastPID2,$lastUpdate) {
	//to be compatible with PHP versions <4.0.5 need to replace without using arrays
	if (empty($lastPID1)) $lastPID1=0;
	if (empty($lastPID2)) $lastPID2=0;
	global $strSQLChangedCount;
	$strSQL = str_replace("[%DATUM%]",$lastUpdate,$strSQLChangedCount);
	$strSQL = str_replace("[%ID1%]",mysql_real_escape_string($lastPID1),$strSQL);
	return str_replace("[%ID2%]",mysql_real_escape_string($lastPID2),$strSQL);
}

function getChangedCoursesXMLSQL($lastPID1,$lastPID2,$lastUpdate,$numCourses) {
	//to be compatible with PHP versions <4.0.5 need to replace without using arrays
	if (empty($lastPID1)) $lastPID1=0;
	if (empty($lastPID2)) $lastPID2=0;
	global $strSQLChangedXML;
	$strSQL = str_replace("[%DATUM%]",$lastUpdate,$strSQLChangedXML);
	$strSQL = str_replace("[%ID1%]",mysql_real_escape_string($lastPID1),$strSQL);
	$strSQL = str_replace("[%ID2%]",mysql_real_escape_string($lastPID2),$strSQL);
	return str_replace("[%TOP%]",mysql_real_escape_string($numCourses),$strSQL);
}

/*****************************
Output functions
*****************************/

function writeHeader() {
	header("Content-Type: text/xml; charset=".CHARACTER_ENCODING);
	header("XCharset:".CHARACTER_ENCODING);
	header("Pragma: no-cache");
	header("Expires: 0");
	echo "<?xml version=\"1.0\" encoding=\"".CHARACTER_ENCODING."\" ?>";
	echo "<iwwb:courses xmlns:iwwb=\"http://www.iwwb.de\\\">";
}

function writeCoursesXML($result) {
	global $strIDFeld1Name,$strIDFeld2Name;
	
	while ($row = db_fetch_assoc($result)) {
		$lastrow = $row;
		echo "<iwwb:course>";
		while (list ($key, $val) = each ($row)) {
		    echo "<".replaceSpecialChar($key).">".writeXML($val)."</".$key.">\n";
		}
		echo "</iwwb:course>";
	}
	
	echo "<iwwb:lastpid>";
	echo "<pid1>".$lastrow[$strIDFeld1Name]."</pid1>";
	if (!empty($lastrow[$strIDFeld2Name])) echo "<pid2>".$lastrow[$strIDFeld2Name]."</pid2>";
	echo "</iwwb:lastpid>";
}

function replaceSpecialChar($str) {
	$str = str_replace(" ","_",$str);
	$str = str_replace("'","_",$str);
	return str_replace("\"","_",$str);
}

function writeChangedCourses($count) {
	echo "<iwwb:course>";
	echo "<cnt>".$count."</cnt>";
	echo "</iwwb:course>";
}

function writeFooter() {
	echo "</iwwb:courses>";
}

function writeError($description) {
	echo "<iwwb:error>";
	echo "<iwwb:errorDescription>".writeXML($description)."</iwwb:errorDescription>";
	echo "<iwwb:errorText>IWWB PHP REST Module. PHP Version: ".phpversion().". DB Error: ".writeXML(db_error())."</iwwb:errorText>";
	echo "</iwwb:error>";
}

function writeDebug($info) {
	global $debug;
	if ($debug) echo "<iwwb:debug>".writeXML($info)."</iwwb:debug>";
}

function writeXML($str) {
	$str = str_replace("&","&amp;",$str);
	$str = str_replace("<","&lt;",$str);
	$str = str_replace(">","&gt;",$str);
	$str = str_replace("\"","&quot;",$str);
	return str_replace("'","&apos;",$str);
}
?>
